(************************************************************************
 * Copyright  1999 by
 *
 * IVS GbR
 * Annaberger Str. 240
 * D-09125 Chemnitz
 *
 * Tel. +49-371-5347 380
 * Fax +49-371-5347 428
 *
 * http://www.ivs-solutions.de
 *
 * $Header: /Private/Steffen Liersch/Projects/LangControl/Source/Demo/DemoMain.pas 2     27.07.99 15:04 Sl $
 *
 * Description: LangControl demo application
 *
 ************************************************************************)

unit DemoMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ComCtrls, Buttons, ToolWin, LangControl, DemoLang;

{ TMainForm }

type
  TMainForm = class(TForm)
    LangControl: TLangControl;
    MainMenu: TMainMenu;
    MenuFile: TMenuItem;
    ItemOpen: TMenuItem;
    ItemSave: TMenuItem;
    ItemSaveAs: TMenuItem;
    N1: TMenuItem;
    ItemExit: TMenuItem;
    MenuEdit: TMenuItem;
    ItemCut: TMenuItem;
    ItemCopy: TMenuItem;
    ItemPaste: TMenuItem;
    MenuOptions: TMenuItem;
    ItemLang: TMenuItem;
    MenuHelp: TMenuItem;
    ItemHelp: TMenuItem;
    N2: TMenuItem;
    ItemAbout: TMenuItem;
    StatusBar: TStatusBar;
    Memo: TRichEdit;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    ToolBar: TToolBar;
    ToolButton1: TToolButton;
    SpeedButton1: TSpeedButton;
    ToolButton2: TToolButton;
    LangComboBox: TLangComboBox;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure LangControlChange(Sender: TObject);
    procedure ItemOpenClick(Sender: TObject);
    procedure ItemSaveClick(Sender: TObject);
    procedure ItemSaveAsClick(Sender: TObject);
    procedure ItemExitClick(Sender: TObject);
    procedure ItemPasteClick(Sender: TObject);
    procedure ItemCutClick(Sender: TObject);
    procedure ItemCopyClick(Sender: TObject);
    procedure ItemLangClick(Sender: TObject);
    procedure ItemHelpClick(Sender: TObject);
    procedure ItemAboutClick(Sender: TObject);
  private
    FFileName:string;
    procedure CheckStatus;
  public
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

{ TMainForm }

procedure TMainForm.CheckStatus;
var
  S:string;
begin
  if FFileName=''then
    StatusBar.Panels[1].Text:=LangControl.GetString('NoFileName')
  else
  begin
    S:=LangControl.GetString('FileName');
    StatusBar.Panels[1].Text:=Format(S,[FFileName]);
  end;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if Memo.Modified then
    ItemSaveAsClick(Self);
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  CheckStatus;
end;

procedure TMainForm.LangControlChange(Sender: TObject);
begin
  CheckStatus;
end;

procedure TMainForm.ItemOpenClick(Sender: TObject);
begin
  if OpenDialog.Execute then
  begin
    Memo.Lines.BeginUpdate;
    try
      Memo.Lines.Clear;
      Memo.Lines.LoadFromFile(OpenDialog.FileName);
    finally
      Memo.Lines.EndUpdate;
    end;
    FFileName:=OpenDialog.FileName;
    Memo.Modified:=False;
    CheckStatus;
  end;
end;

procedure TMainForm.ItemSaveClick(Sender: TObject);
begin
  if FFileName=''then
    ItemSaveAsClick(Self)
  else
  begin
    Memo.Lines.SaveToFile(FFileName);
    Memo.Modified:=False;
  end;
end;

procedure TMainForm.ItemSaveAsClick(Sender: TObject);
begin
  if SaveDialog.Execute then
  begin
    Memo.Lines.SaveToFile(SaveDialog.FileName);
    FFileName:=SaveDialog.FileName;
    Memo.Modified:=False;
    CheckStatus;
  end;
end;

procedure TMainForm.ItemExitClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.ItemPasteClick(Sender: TObject);
begin
  Memo.PasteFromClipboard;
end;

procedure TMainForm.ItemCutClick(Sender: TObject);
begin
  Memo.CutToClipboard;
end;

procedure TMainForm.ItemCopyClick(Sender: TObject);
begin
  Memo.CopyToClipboard;
end;

procedure TMainForm.ItemLangClick(Sender: TObject);
var
  F:TLangForm;
begin
  F:=TLangForm.Create(Application);
  try
    F.ShowModal;
  finally
    F.Free;
  end;
end;

procedure TMainForm.ItemHelpClick(Sender: TObject);
begin
  ShowMessage(LangControl.GetString('EHelpError'));
end;

procedure TMainForm.ItemAboutClick(Sender: TObject);
begin
  ShowMessage(
    'Copyright  1999 IVS GbR'#13#10+
    'www.ivs-solutions.de');
end;

end.
